package bubulle;
public class Angle {

	//Retourne si l'angle AB-AC est inférieur à inf (en degre)
	public static boolean angle(double[] coordA, double[] coordB, double[] coordC, double inf) {
		if(coordA.length < 2 && coordB.length < 2 && coordC.length < 2)
			return angle(coordA[0], coordA[1], coordB[0], coordB[1], coordC[0], coordC[1], inf);
		return false;
	}
	
	//Cas spécial pour les bulles
	public static boolean angle(Bulle a, Bulle b, Bulle c, double inf) {
		return angle(a.getX(), a.getY(), b.getX(), b.getY(), c.getX(), c.getY(), inf);
	}
	
	//Retourne si l'angle AB-AC est inférieur à inf (en degre)
	public static boolean angle(double xA, double yA, double xB, double yB, double xC, double yC, double inf) {
		double distAB, distAC, distBC, cosA, arcosA;
		
		//Distance séparant A et B
		distAB = Math.sqrt(Math.pow( (xB-xA) , 2) + Math.pow( (yB-yA) , 2));
		//Distance séparant A et C
		distAC = Math.sqrt(Math.pow( (xC-xA) , 2) + Math.pow( (yC-yA) , 2));
		//Distance séparant B et C
		distBC = Math.sqrt(Math.pow( (xC-xB) , 2) + Math.pow( (yC-yB) , 2));
		
		//cosinus de l'angle AB-AC (en radian)
		cosA = ( - Math.pow(distBC, 2) + Math.pow(distAC, 2) + Math.pow(distAB, 2) ) / ( 2 * distAC * distAB );
		
		//angle AB-AC (en degre)
		arcosA = Math.acos(cosA) * 180 / Math.PI;
		
		System.out.println(arcosA);//DEBUG 
		
		//Vérification de l'angle inférieur (ou egal) à la valeur attendu
		return arcosA <= inf;
	}

	public static void main(String[] args) {
		System.out.println(angle(0,0 , 1,0 , 0,1, 100));
		System.out.println(angle(0,0 , 1,0 , 0,1, 50));
	}
	
}
